## hydrogen 1.1.1+52.gb917e057

=== src/cli/CMakeLists.txt ===

FILE(GLOB_RECURSE h2cli_SRCS *.cpp)

INCLUDE_DIRECTORIES(
    ${CMAKE_SOURCE_DIR}/src                     # top level headers
    ${CMAKE_BINARY_DIR}/src                     # generated config.h
    ${QT_INCLUDES}
    ${LASH_INCLUDE_DIRS}
    ${OSC_INCLUDE_DIRS}
    ${LIBSNDFILE_INCLUDE_DIRS}
    ${JACK_INCLUDE_DIRS}
)

ADD_EXECUTABLE(h2cli WIN32 MACOSX_BUNDLE ${h2cli_SRCS} )

SET_PROPERTY(TARGET h2cli PROPERTY CXX_STANDARD 17)
TARGET_LINK_LIBRARIES(h2cli
	hydrogen-core-${VERSION}
	Qt5::Widgets
	${LASH_LIBRARIES}
	${OSC_LIBRARIES}
	)

ADD_DEPENDENCIES(h2cli hydrogen-core-${VERSION})

INSTALL(TARGETS h2cli RUNTIME DESTINATION ${H2_BIN_PATH} BUNDLE DESTINATION ${H2_BIN_PATH})

=== src/core/CMakeLists.txt ===

CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/config.h.in" "${CMAKE_CURRENT_BINARY_DIR}/config.h" @ONLY)

FILE(GLOB_RECURSE hydrogen_INCLUDES *.h)
FILE(GLOB_RECURSE hydrogen_SOURCES *.cpp *.cc *.c)
LIST(APPEND hydrogen_INCLUDES ${CMAKE_CURRENT_BINARY_DIR}/config.h)

ADD_LIBRARY( hydrogen-core-${VERSION} ${H2CORE_LIBRARY_TYPE} ${hydrogen_SOURCES})
INCLUDE_DIRECTORIES( include
    ${CMAKE_SOURCE_DIR}/src                     # regular headers
    ${CMAKE_SOURCE_DIR}/include                 # regular headers
    ${CMAKE_CURRENT_BINARY_DIR}/../             # generated config.h
    ${QT_INCLUDES}
    ${LIBTAR_INCLUDE_DIRS}
    ${LIBARCHIVE_INCLUDE_DIRS}
    ${LIBSNDFILE_INCLUDE_DIRS}
    ${PULSEAUDIO_INCLUDE_DIRS}
    ${ALSA_INCLUDE_DIRS}
    ${OSS_INCLUDE_DIRS}
    ${JACK_INCLUDE_DIRS}
    ${PORTAUDIO_INCLUDE_DIRS}
    ${PORTMIDI_INCLUDE_DIRS}
    ${COREAUDIO_INCLUDE_DIRS}
    ${COREMIDI_INCLUDE_DIRS}
    ${LASH_INCLUDE_DIRS}
    ${LRDF_INCLUDE_DIRS}
    ${OSC_INCLUDE_DIRS}
    ${RUBBERBAND_INCLUDE_DIRS}
)

TARGET_LINK_LIBRARIES(hydrogen-core-${VERSION}
    ${LIBTAR_LIBRARIES}
    ${LIBARCHIVE_LIBRARIES}
    ${LIBSNDFILE_LIBRARIES}
    ${ALSA_LIBRARIES}
    ${OSS_LIBRARIES}
    ${JACK_LIBRARIES}
    ${PORTAUDIO_LIBRARIES}
    ${PORTMIDI_LIBRARIES}
    ${AUDIOUNIT_LIBRARY}
    ${CORESERVICES_LIBRARY}
    ${COREAUDIO_LIBRARIES}
    ${COREMIDI_LIBRARIES}
    ${PULSEAUDIO_LIBRARIES}
    ${LASH_LIBRARIES}
    ${LRDF_LIBRARIES}
    ${RUBBERBAND_LIBRARIES}
    ${ZLIB_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
    ${OSC_LIBRARIES}
)

TARGET_LINK_LIBRARIES(hydrogen-core-${VERSION}
	Qt5::Core
	Qt5::Xml
	Qt5::XmlPatterns
)

#SET_TARGET_PROPERTIES(hydrogen-core-${VERSION} PROPERTIES PUBLIC_HEADER   "${hydrogen_INCLUDES}" )
SET_PROPERTY(TARGET hydrogen-core-${VERSION} PROPERTY CXX_STANDARD 17)


IF(WIN32)
    # On Windows we do not want to install import library (.dll.a)
    INSTALL(TARGETS hydrogen-core-${VERSION}
        LIBRARY DESTINATION "${H2_LIB_PATH}"
        RUNTIME DESTINATION "${H2_LIB_PATH}"
    )
ELSE()
    INSTALL(TARGETS hydrogen-core-${VERSION}
        LIBRARY DESTINATION "${H2_LIB_PATH}"
        RUNTIME DESTINATION "${H2_LIB_PATH}"
        ARCHIVE DESTINATION "${H2_LIB_PATH}"
    )
ENDIF()

IF(NOT APPLE AND NOT WIN32)
    INSTALL(DIRECTORY ${CMAKE_SOURCE_DIR}/src/core DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/hydrogen" FILES_MATCHING PATTERN "*.h" PATTERN ".svn" EXCLUDE)
    INSTALL(FILES "${CMAKE_CURRENT_BINARY_DIR}/config.h" DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/hydrogen" )
ENDIF()

=== src/gui/CMakeLists.txt ===

FILE(GLOB_RECURSE hydrogen_SRCS src/*.cpp src/*.h)

# add undiscovered dependencies to generated config.h
INCLUDE(AddFileDependencies)
FOREACH( _file ${hydrogen_H} ${hydrogen_SRCS})
    FILE(READ "${_file}" _FILE_CONTENT)
    IF( "${_FILE_CONTENT}" MATCHES "H2CORE_HAVE_" )
        ADD_FILE_DEPENDENCIES( ${_file} ${CMAKE_BINARY_DIR}/src/core/config.h)
    ENDIF()
ENDFOREACH()

INCLUDE_DIRECTORIES(
    ${CMAKE_CURRENT_BINARY_DIR}                 # ui_ headers
    ${CMAKE_CURRENT_SOURCE_DIR}/src             # gui headers
    ${CMAKE_BINARY_DIR}/src                     # generated config.h
    ${CMAKE_SOURCE_DIR}/src                     # top level headers
    ${QT_INCLUDES}
    ${LASH_INCLUDE_DIRS}
    ${LIBARCHIVE_INCLUDE_DIRS}
    ${LIBSNDFILE_INCLUDE_DIRS}
    ${JACK_INCLUDE_DIRS}
    ${PORTAUDIO_INCLUDE_DIRS}
)

IF(APPLE)
	# set how it shows up in the Info.plist file
     	SET(MACOSX_BUNDLE_INFO_STRING "Hydrogen for Mac")
	SET(MACOSX_BUNDLE_ICON_FILE "icon.icns")
	SET(MACOSX_BUNDLE_GUI_IDENTIFIER "Hydrogen")
	SET(MACOSX_BUNDLE_LONG_VERSION_STRING "${VERSION}")
	#this has to be short since it appears as the application name in the menu bar
	SET(MACOSX_BUNDLE_BUNDLE_NAME "Hydrogen")
	SET(MACOSX_BUNDLE_SHORT_VERSION_STRING "${VERSION}")
	SET(MACOSX_BUNDLE_BUNDLE_VERSION "${VERSION}")
	SET(MACOSX_BUNDLE_COPYRIGHT "Hydrogen Developers, 2009")

  	# set where in the bundle to put the icns file
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_SOURCE_DIR}/data/img/gray/icon.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
	# include the icns file in the target
	SET(hydrogen_SRCS ${hydrogen_SRCS} ${CMAKE_SOURCE_DIR}/data/img/gray/icon.icns)
	
	#copy the data folder
    FILE(COPY ${CMAKE_SOURCE_DIR}/data DESTINATION hydrogen.app/Contents/Resources PATTERN ".svn" EXCLUDE PATTERN i18n EXCLUDE)
  	
ENDIF()

ADD_EXECUTABLE(hydrogen WIN32 MACOSX_BUNDLE ${hydrogen_SRCS} ${hydrogen_MOC} ${hydrogen_UIS_H} ${CMAKE_SOURCE_DIR}/windows/icon.rc)
SET_PROPERTY(TARGET hydrogen PROPERTY CXX_STANDARD 17)
if(APPLE)
    add_custom_command(
        TARGET hydrogen
        POST_BUILD
        COMMAND plutil -replace NSPrincipalClass -string NSApplication hydrogen.app/Contents/Info.plist
    )
    add_custom_command(
        TARGET hydrogen
        POST_BUILD
        COMMAND plutil -replace NSHighResolutionCapable -bool true hydrogen.app/Contents/Info.plist
    )
    add_custom_command(
        TARGET hydrogen
        POST_BUILD
        COMMAND
            plutil -extract CFBundleDocumentTypes json
                   -o /dev/null
                   hydrogen.app/Contents/Info.plist >/dev/null
            || plutil -insert CFBundleDocumentTypes
                      -json
                         \"` cat ${CMAKE_SOURCE_DIR}/macos/CFBundleDocumentTypes.json `\"
                       hydrogen.app/Contents/Info.plist )

    ADD_DEPENDENCIES(hydrogen ${CMAKE_SOURCE_DIR}/macos/CFBundleDocumentTypes.json)

endif()

TARGET_LINK_LIBRARIES(hydrogen
	hydrogen-core-${VERSION}
	Qt5::Widgets
)

# Precompiled headers for Qt and std::vector. These dramatically reduce GUI build times
if(${CMAKE_VERSION} VERSION_GREATER_EQUAL 3.16)
	target_precompile_headers(hydrogen
		PUBLIC
			<QtGui>
			<QtWidgets>
			<vector> )
endif()


ADD_DEPENDENCIES(hydrogen hydrogen-core-${VERSION})

INSTALL(TARGETS hydrogen RUNTIME DESTINATION ${H2_BIN_PATH} BUNDLE DESTINATION ${H2_BIN_PATH})

=== src/tests/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
add_definitions()
include_directories(
    ${CMAKE_SOURCE_DIR}/src/core/include            # core headers
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_BINARY_DIR}/src                         # generated config.h
    ${QT_INCLUDES}
    ${JACK_INCLUDE_DIRS}
    ${CPPUNIT_INCLUDE_DIRS}
    ${LIBSNDFILE_INCLUDE_DIRS}
    ${RUBBERBAND_INCLUDE_DIRS}
)

FILE(GLOB_RECURSE TESTS_SRCS *.cpp)
link_directories()
add_executable(tests ${TESTS_SRCS})

SET_PROPERTY(TARGET tests PROPERTY CXX_STANDARD 17)

target_link_libraries(tests
	hydrogen-core-${VERSION}
	${CPPUNIT_LIBRARIES}
	Qt5::Core
	Qt5::Test
	Qt5::Network
)

add_dependencies(tests hydrogen-core-${VERSION})

=== debian/changelog ===
hydrogen (1.1.1+52.gb917e057-1) unstable; urgency=medium

  * Import upstream snapshot. (Closes: #1005912)
  * Rebase patch queue onto this version.
  * Temporarily disable docs install (they don't exist in dev releases).
  * Overwrite source/lintian-overrides with hydrogen.lintian-overrides.

 -- Nicholas D Steeves <sten@debian.org>  Tue, 12 Apr 2022 17:30:24 -0400

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/hydrogen-$1\.tar\.gz/ \
  https://github.com/hydrogen-music/hydrogen/tags .*/v?(\d\S+)\.tar\.gz

## hydrogen 1.2.0~beta1%2Bdfsg

=== debian/tests/control ===
# "allow-stderr" is snd's work.  I suspect it's needed because
# hydrogen complains about nonfunctioning jackd on buildd, and jackd
# on a alsa-dummy interface wouldn't affect the results of this simple
# export from xml to wav test...so I think it's probably the right
# decision to allow this -- NicholasDSteeves

Tests: h2cli-convert
Depends: @, mediainfo
Restrictions: allow-stderr

## hydrogen 1.2.0~beta1+dfsg

=== CMakeLists.txt ===
#
# CMAKE SETUP
#

CMAKE_MINIMUM_REQUIRED(VERSION 3.8)
SET(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
# The CMake Policy mechanism is designed to help keep existing projects building as new versions of CMake introduce changes in behavior.
# http://www.cmake.org/cmake/help/cmake2.6docs.html#command:cmake_policy
IF(COMMAND CMAKE_POLICY)
#	CMAKE_POLICY(SET CMP0005 NEW)
	CMAKE_POLICY(SET CMP0003 NEW)   # add_library
	CMAKE_POLICY(SET CMP0006 NEW)   # bundle destination property
ENDIF()
#
# PROJECT INFO
#
PROJECT(hydrogen)
SET(VERSION_MAJOR "1")
SET(VERSION_MINOR "2")
SET(VERSION_PATCH "0")
SET(VERSION_SUFFIX "beta")


SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")


IF(VERSION_SUFFIX)
	SET(DISPLAY_VERSION "${VERSION}-${VERSION_SUFFIX}")
ELSE()
	EXECUTE_PROCESS(COMMAND git log --pretty=format:'%h' -n 1 OUTPUT_VARIABLE GIT_REVISION )
	SET(DISPLAY_VERSION "${VERSION}-${GIT_REVISION}")
ENDIF(VERSION_SUFFIX)

# Consider any tagged commit as a release build
EXECUTE_PROCESS(COMMAND git describe --exact-match --tags OUTPUT_VARIABLE GIT_TAG)
IF(GIT_TAG)
        SET(IS_DEVEL_BUILD "false")
ELSE()
        SET(IS_DEVEL_BUILD "true")
ENDIF()


SET(LIBSNDFILE_VERSION_PREV "1.0.17")

#
# CONFIG OPTIONS
#
SET(WANT_LIBTAR TRUE)
OPTION(WANT_DEBUG           "Build with debug information" ON)
IF(APPLE)
    OPTION(WANT_SHARED      "Build the core library shared." OFF)
    OPTION(WANT_ALSA        "Include ALSA (Advanced Linux Sound Architecture) support" OFF)
ELSE()
    OPTION(WANT_SHARED      "Build the core library shared." ON)
    OPTION(WANT_ALSA        "Include ALSA (Advanced Linux Sound Architecture) support" ON)
ENDIF()

OPTION(WANT_LIBARCHIVE      "Enable use of libarchive instead of libtar" ON)
OPTION(WANT_LADSPA          "Enable use of LADSPA plugins" ON)

IF(APPLE)
	OPTION(WANT_OSC  "Enable OSC support" OFF)
ELSE()
	OPTION(WANT_OSC  "Enable OSC support" ON)
ENDIF()

IF("${CMAKE_SYSTEM_NAME}" MATCHES "NetBSD")
	OPTION(WANT_OSS          "Include OSS (Open Sound System) support" ON)
ELSE()
	OPTION(WANT_OSS          "Include OSS (Open Sound System) support" OFF)
ENDIF()

IF(MINGW)
	OPTION(WANT_PORTAUDIO    "Include PortAudio support" ON)
	OPTION(WANT_PORTMIDI     "Include PortMidi support" ON)
ELSE()
	OPTION(WANT_PORTAUDIO    "Include PortAudio support" OFF)
	OPTION(WANT_PORTMIDI     "Include PortMidi support" OFF)
ENDIF()
OPTION(WANT_JACK         "Include JACK (Jack Audio Connection Kit) support" ON)
OPTION(WANT_PULSEAUDIO   "Include PulseAudio support" ON)
OPTION(WANT_LASH         "Include LASH (Linux Audio Session Handler) support" OFF)
OPTION(WANT_LRDF         "Include LRDF (Lightweight Resource Description Framework with special support for LADSPA plugins) support" OFF)
OPTION(WANT_RUBBERBAND   "Include RubberBand (Audio Time Stretcher Library) support" OFF)
IF(APPLE)
    OPTION(WANT_COREAUDIO   "Include CoreAudio support" ON)
    OPTION(WANT_COREMIDI    "Include CoreMidi support" ON)
    OPTION(WANT_BUNDLE      "Build a MAC OSX bundle application" ON)
ENDIF()

OPTION(WANT_CPPUNIT         "Include CppUnit test suite" ON)

include(Sanitizers)
INCLUDE(StatusSupportOptions)

IF(WANT_DEBUG)
    SET(CMAKE_BUILD_TYPE Debug)
    SET(H2CORE_HAVE_DEBUG TRUE)
ELSE()
    SET(CMAKE_BUILD_TYPE Release)
    SET(H2CORE_HAVE_DEBUG FALSE)
ENDIF()


OPTION(WANT_CLANG_TIDY "Use clang-tidy to check the sourcecode" OFF)
find_program(CLANG_TIDY_CMD NAMES clang-tidy)
IF(CLANG_TIDY_CMD)
  #use config from .clang-tidy
  SET(CLANG_TIDY_LIBRARIES ${CLANG_TIDY_CMD}) # Required for summary
  SET(CLANG_TIDY_FOUND TRUE) # Required for summary
ELSE()
  SET(CLANG_TIDY_FOUND FALSE) # Required for summary
ENDIF()
IF(CLANG_TIDY_CMD AND WANT_CLANG_TIDY)
  #use config from .clang-tidy
  SET(CMAKE_CXX_CLANG_TIDY clang-tidy)
ENDIF()
COMPUTE_PKGS_FLAGS(CLANG_TIDY) # Required for summary

IF(WANT_BUNDLE)
    SET(H2CORE_HAVE_BUNDLE TRUE)
ELSE()
    SET(H2CORE_HAVE_BUNDLE FALSE)
ENDIF()

IF(WANT_SHARED)
    SET(H2CORE_LIBRARY_TYPE SHARED)
ELSE()
    SET(H2CORE_LIBRARY_TYPE STATIC)
ENDIF()

IF(WANT_DEBUG)
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0")
ELSE()
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -ffast-math")
ENDIF()

IF (NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-implement-inlines")
ENDIF()

SET(CMAKE_CXX_FLAGS_RELEASE "")

SET(CMAKE_CXX_FLAGS_DEBUG "-g ")#-Winline")

#
# MANDATORY PKGS AND DEFAULT OPTIONS
#
MANDATORY_PKG(Threads)
MANDATORY_PKG(LIBSNDFILE)

# http://doc.qt.io/qt-5/cmake-manual.html
FIND_PACKAGE(Qt5Widgets REQUIRED)
FIND_PACKAGE(Qt5Test REQUIRED)
FIND_PACKAGE(Qt5Svg REQUIRED)
FIND_PACKAGE(Qt5Xml REQUIRED)
FIND_PACKAGE(Qt5XmlPatterns REQUIRED)
FIND_PACKAGE(Qt5LinguistTools REQUIRED)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)

IF(APPLE)
    INCLUDE_DIRECTORIES("/opt/local/include")
    LINK_DIRECTORIES("/opt/local/lib")

    #Without setting this, installation would go into /usr/local, which does not exist per default
    SET(CMAKE_INSTALL_PREFIX "/usr" )
ELSE(APPLE)
    SET(OSS_LIB_PATHS "${CMAKE_INSTALL_FULL_LIBDIR}/oss/lib" "/usr/local/lib${LIB_SUFFIX}/oss/lib" )
ENDIF(APPLE)


#Installation paths
INCLUDE(GNUInstallDirs)
IF(WIN32)
    SET(H2_BIN_PATH ".")
    SET(H2_LIB_PATH ".")
    SET(H2_DATA_PATH ".")
    SET(H2_SYS_PATH "hydrogen")
ELSE()
    SET(H2_BIN_PATH ${CMAKE_INSTALL_BINDIR})
    SET(H2_LIB_PATH ${CMAKE_INSTALL_LIBDIR})
    SET(H2_DATA_PATH "${CMAKE_INSTALL_DATADIR}/hydrogen")
    SET(H2_SYS_PATH "${CMAKE_INSTALL_FULL_DATAROOTDIR}/hydrogen")
ENDIF()
SET(H2_USR_PATH ".hydrogen")

SET(MAX_INSTRUMENTS 1000 CACHE STRING "Maximum number of instruments")
SET(MAX_COMPONENTS  32   CACHE STRING "Maximum number of components")
SET(MAX_NOTES       192  CACHE STRING "Maximum number of notes")
SET(MAX_FX          4    CACHE STRING "Maximum number of effects")
SET(MAX_BUFFER_SIZE 8192 CACHE STRING "Maximum size of buffer")

#
# HEADER LIBRARY FUNCTIONS
#
INCLUDE(CompileHelper)
INCLUDE(FindHelper)
INCLUDE(FindLadspa)
INCLUDE(CheckIncludeFiles)
INCLUDE(CheckLibraryExists)
INCLUDE(FindZLIB)
INCLUDE(FindThreads)
COMPILE_HELPER(SSCANF ${CMAKE_SOURCE_DIR}/cmake/sscanf sscanf )
COMPILE_HELPER(RTCLOCK ${CMAKE_SOURCE_DIR}/cmake/rtclock rtclock )
CHECK_INCLUDE_FILES(sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES(sys/stat.h HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILES(libtar.h HAVE_LIBTAR_H)
CHECK_INCLUDE_FILES(execinfo.h HAVE_EXECINFO_H)
FIND_PACKAGE(Backtrace)
CHECK_LIBRARY_EXISTS(tar tar_open "" HAVE_LIBTAR_OPEN)
CHECK_LIBRARY_EXISTS(tar tar_close "" HAVE_LIBTAR_CLOSE)
CHECK_LIBRARY_EXISTS(tar tar_extract_all "" HAVE_LIBTAR_EXTRACT_ALL)
IF(HAVE_LIBTAR_H AND HAVE_LIBTAR_OPEN AND HAVE_LIBTAR_CLOSE AND HAVE_LIBTAR_EXTRACT_ALL)
    SET(LIBTAR_OK TRUE)
ELSE()
    SET(LIBTAR_OK FALSE)
ENDIF()
FIND_HELPER(LIBTAR tar tar.h tar)
IF( NOT LIBTAR_FOUND OR NOT LIBTAR_OK OR NOT ZLIB_FOUND )
    SET(WANT_LIBTAR FALSE)
    MANDATORY_PKG(LIBARCHIVE)
ENDIF()
FIND_HELPER(LIBARCHIVE libarchive archive.h archive)
IF( WANT_LIBARCHIVE AND LIBARCHIVE_FOUND)
    SET(WANT_LIBTAR FALSE)
ENDIF()
FIND_HELPER(LIBSNDFILE sndfile sndfile.h sndfile)
FIND_HELPER(ALSA alsa alsa/asoundlib.h asound )
FIND_LADSPA(LADSPA ladspa.h noise)

FIND_HELPER(OSC liblo lo/lo.h lo)

IF("${CMAKE_SYSTEM_NAME}" MATCHES "NetBSD")
	FIND_HELPER(OSS oss sys/soundcard.h ossaudio )
ELSE()
	FIND_HELPER(OSS oss sys/soundcard.h OSSlib )
ENDIF()

FIND_HELPER(JACK jack jack/jack.h jack)
CHECK_LIBRARY_EXISTS(jack jack_port_rename "" HAVE_JACK_PORT_RENAME)
IF(APPLE)
    FIND_LIBRARY(AUDIOUNIT_LIBRARY AudioUnit)
    FIND_LIBRARY(CORESERVICES_LIBRARY CoreServices)
    FIND_HELPER(COREAUDIO CoreAudio-2.0 coreaudio.h coreaudio)
    FIND_HELPER(COREMIDI CoreMidi coremidi.h coremidi)
ENDIF()
FIND_HELPER(PORTAUDIO portaudio-2.0 portaudio.h portaudio)
FIND_HELPER(PORTMIDI portmidi portmidi.h portmidi)
FIND_HELPER(PULSEAUDIO libpulse pulse/pulseaudio.h pulse)
FIND_HELPER(LASH lash-1.0 lash/lash.h lash)
FIND_HELPER(LRDF lrdf lrdf.h lrdf)

FIND_HELPER(RUBBERBAND rubberband rubberband/RubberBandStretcher.h rubberband)
FIND_HELPER(CPPUNIT cppunit cppunit/TestCase.h cppunit)


# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
#set(CMAKE_AUTOMOC ON)


find_package(Doxygen)
if(DOXYGEN_FOUND)
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
	add_custom_target(doc_dir ALL COMMAND ${CMAKE_COMMAND}
		-E make_directory ${CMAKE_CURRENT_BINARY_DIR}/docs)
	add_custom_target(doxygen_dir ALL COMMAND ${CMAKE_COMMAND}
		-E make_directory ${CMAKE_CURRENT_BINARY_DIR}/doxygen)
	add_custom_target(doc
		${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
		DEPENDS doc_dir doxygen_dir
		WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/docs
		COMMENT "Generating API documentation with Doxygen"
		VERBATIM)
endif(DOXYGEN_FOUND)

#
# COMPUTE H2CORE_HAVE_xxx xxx_STATUS_REPORT
#
SET(STATUS_LIST LIBSNDFILE LIBTAR LIBARCHIVE LADSPA ALSA OSS JACK OSC COREAUDIO COREMIDI PORTAUDIO PORTMIDI PULSEAUDIO LASH LRDF RUBBERBAND CPPUNIT )
FOREACH( _pkg ${STATUS_LIST})
    COMPUTE_PKGS_FLAGS(${_pkg})
ENDFOREACH()

# LIBSNDFILE CHECKS
STRING( COMPARE GREATER "${LIBSNDFILE_VERSION}" "${LIBSNDFILE_VERSION_PREV}" LIBSNDFILE_VERSION_OK)
IF(LIBSNDFILE_VERSION_OK)
    SET(LIBSNDFILE_MSG "libsndfile supports FLAC and OGG sound file formats")
ELSE()
	SET(LIBSNDFILE_MSG "libsndfile version must be greater than ${LIBSNDFILE_VERSION_PREV} to support FLAC and OGG sound file formats. Found version: ${LIBSNDFILE_VERSION}")
ENDIF()

# RUBBERBAND information
SET(LIBRUBBERBAND_MSG "The use of librubberband2 is marked as experimental.
*				 Because the current implementation produce wrong timing!
*				 So long this bug isn't solved, please disable this option.
*				 If rubberband-cli is installed, the hydrogen rubberband-function
*				 will work properly as expected.")

IF(WIN32)
    SET(CMAKE_COLOR_MAKEFILE OFF)
ENDIF()

#
# CONFIG PROCESS SUMMARY
#
SET(reset "${_escape}[0m")
SET(red "${_escape}[1;31m")
SET(purple "${_escape}[1;35m")
SET(cyan "${_escape}[1;36m")

COLOR_MESSAGE("${cyan}Installation Summary${reset}
--------------------
* Install Directory            : ${CMAKE_INSTALL_PREFIX}
* User path                    : ${H2_USR_PATH}
* System path                  : ${H2_SYS_PATH}
* Bin path                     : ${H2_BIN_PATH}
* Lib path                     : ${H2_LIB_PATH}
* Data path                    : ${H2_DATA_PATH}
* core library build as        : ${H2CORE_LIBRARY_TYPE}
* debug capabilities           : ${H2CORE_HAVE_DEBUG}
* macosx bundle                : ${H2CORE_HAVE_BUNDLE}
* fat build                    : ${WANT_FAT_BUILD}\n"
)

COLOR_MESSAGE("${cyan}Main librarires${reset}")
COLOR_MESSAGE("* ${purple}libQt${reset}                        : ${Qt5Widgets_VERSION}")
COLOR_MESSAGE("* ${purple}libsndfile${reset}                   : ${LIBSNDFILE_STATUS}
*                                ${LIBSNDFILE_MSG}
* ${purple}libtar${reset}                       : ${LIBTAR_STATUS}
* ${purple}libarchive${reset}                   : ${LIBARCHIVE_STATUS}
* ${purple}ladspa${reset}                       : ${LADSPA_STATUS}\n"
)

COLOR_MESSAGE("${cyan}Supported audio interfaces${reset}
--------------------------
* ${purple}ALSA${reset}                         : ${ALSA_STATUS}
* ${purple}OSS${reset}                          : ${OSS_STATUS}
* ${purple}JACK${reset}                         : ${JACK_STATUS}
* ${purple}OSC${reset}                          : ${OSC_STATUS}
* ${purple}CoreAudio${reset}                    : ${COREAUDIO_STATUS}
* ${purple}CoreMidi${reset}                     : ${COREMIDI_STATUS}
* ${purple}PortAudio${reset}                    : ${PORTAUDIO_STATUS}
* ${purple}PortMidi${reset}                     : ${PORTMIDI_STATUS}
* ${purple}PulseAudio${reset}                   : ${PULSEAUDIO_STATUS}\n"
)

COLOR_MESSAGE("${cyan}Useful extensions${reset}
-----------------------------------------

=== cmake/rtclock/CMakeLists.txt ===

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
PROJECT($CMAKE_PROJECT_NAME)
add_definitions()
include_directories()
link_directories()
add_executable(rtclock rtclock.c)
target_link_libraries(rtclock "rt" )

=== data/i18n/CMakeLists.txt ===
# make clean does not delete *.ts and *.qm files
SET_DIRECTORY_PROPERTIES(PROPERTIES CLEAN_NO_CUSTOM 1)

FILE(GLOB TS_FILES ${CMAKE_CURRENT_LIST_DIR}/*.ts)

QT5_ADD_TRANSLATION(QM_FILES ${TS_FILES})
ADD_CUSTOM_TARGET(translations ALL DEPENDS ${QM_FILES})

IF(MINGW)
	INSTALL(FILES ${QM_FILES} DESTINATION "./data/i18n")
ELSE()
	INSTALL(FILES ${QM_FILES} DESTINATION "${H2_SYS_PATH}/data/i18n")
ENDIF()

=== src/core/CMakeLists.txt ===
--- 
+++ 
@@ -54,6 +54,7 @@
 	Qt5::Core
 	Qt5::Xml
 	Qt5::XmlPatterns
+	Qt5::Gui # For QColor
 )
 
 #SET_TARGET_PROPERTIES(hydrogen-core-${VERSION} PROPERTIES PUBLIC_HEADER   "${hydrogen_INCLUDES}" )

=== debian/changelog ===
hydrogen (1.2.0~beta1+dfsg-1build4) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 07 Apr 2024 07:15:48 +0000

hydrogen (1.2.0~beta1+dfsg-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 08:57:09 +0000

hydrogen (1.2.0~beta1+dfsg-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:36:43 +0000

hydrogen (1.2.0~beta1+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libarchive13t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 09 Mar 2024 07:21:33 +0000

hydrogen (1.2.0~beta1+dfsg-1) unstable; urgency=medium

  * New upstream release 1.2.0-beta1+dfsg.
  * Clean Hydrogen of currently non-DFSG new documentation
    - Use Files-Excluded to exclude tutorial_en.html, which has no source.
    - Add dversion mangling so that uscan will continue to function correctly.
  * Rebase patch queue onto this release.
  * Add libqt5svg5-dev and qttools5-dev-tools to build deps.
  * Drop now irrelevant and incorrect usr/share/hydrogen/data/*.h2song from
    hydrogen-data.install.
  * Install new default theme.
  * Copyright: Update my email address and years.
  * Update watch file to correctly mangle upstream prerelease version
    separator; The effect is $1-foo-1 to $1~foo-1 in the Debian package; This
    is needed because all prereleases should sort lower than the actual
    upstream release.

  [ Nicholas D Steeves and Dennis Braun ]
  * Declare Standards-Version: 4.6.1 (no changes required).

 -- Nicholas D Steeves <sten@debian.org>  Sun, 27 Nov 2022 14:22:34 -0500

=== debian/control ===
Source: hydrogen
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Nicholas D Steeves <sten@debian.org>,
 Dennis Braun <d_braun@kabelmail.de>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 qtbase5-dev,
 libqt5xmlpatterns5-dev,
 qttools5-dev,
 libcppunit-dev,
 libz-dev,
 pkg-config,
 libarchive-dev,
 docbook-utils,
 poxml,
 xmlto,
 libxml2-utils,
 libasound2-dev [linux-any],
 libjack-dev,
 liblrdf-dev,
 libsndfile1-dev,
 portaudio19-dev,
 libportmidi-dev [linux-any],
 libpulse-dev,
 liblo-dev,
 libqt5svg5-dev,
 qttools5-dev-tools
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: http://www.hydrogen-music.org/
# Unfortunately, as of 2020-11-26, https://www.hydrogen-music.org/ has the
# following SSL cert issue: NET::ERR_CERT_COMMON_NAME_INVALID
# This is remains unfixed as of 2022-09-28, and was reported here:
# https://github.com/hydrogen-music/hydrogen/issues/1658
Vcs-Git: https://salsa.debian.org/multimedia-team/hydrogen.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/hydrogen

Package: hydrogen
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 hydrogen-data (= ${source:Version})
Recommends:
 hydrogen-drumkits,
 hydrogen-doc,
 rubberband-cli
Suggests:
 ladspa-plugin
Breaks: hydrogen-data (<< 1.0.1-2)
Replaces: hydrogen-data (<< 1.0.1-2)
Description: advanced drum machine/step sequencer
 Hydrogen is an advanced drum machine which provides a professional,
 yet simple and intuitive, pattern-based drum programming interface.
 .
 General features:
  * Very user-friendly, modular, fast and intuitive graphical interface
    based on Qt 5.
  * Sample-based stereo audio engine, with import of sound samples in
    .wav, .au and .aiff formats.
  * Support of samples in compressed FLAC file.
 .
 Sequencer and mixer features:
  * Pattern-based sequencer, with unlimited number of patterns and
    ability to chain patterns into a song.
  * Up to 64 ticks per pattern with individual level per event and
    variable pattern length.
  * 32 instrument tracks with volume, mute, solo, pan capabilities.
  * Multi layer support for instruments (up to 16 samples for each
    instrument).
  * Ability to import/export song files.
  * Unique human velocity, human time, pitch and swing functions.
  * Multiple patterns playing at once.
 .
 Other features:
  * JACK, ALSA, PortAudio, OSS and PulseAudio audio drivers.
  * ALSA MIDI and PortMidi input with assignable midi-in channel (1..16,
    ALL).
  * Import/export of drumkits.
  * Export song to wav file.
  * Export song to midi file.

Package: hydrogen-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: hydrogen
Breaks: hydrogen (<< 0.9.7-5~)
Replaces: hydrogen (<< 0.9.7-5~)
Description: advanced drum machine/step sequencer (data)
 Hydrogen is an advanced drum machine which provides a professional,
 yet simple and intuitive, pattern-based drum programming interface.
 .
 This package contains the architecture-independent data files.

Package: hydrogen-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: hydrogen (<< 0.9.7-1~)
Replaces: hydrogen (<< 0.9.7-1~)
Description: advanced drum machine/step sequencer (doc)
 Hydrogen is an advanced drum machine which provides a professional,
 yet simple and intuitive, pattern-based drum programming interface.
 .
 This package contains the architecture-independent documentation.

=== debian/watch ===
version=4
opts=dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//,uversionmangle=s/(\d)-(alpha|beta|rc)/$1~$2/,repacksuffix=+dfsg,compression=gz \
  https://github.com/hydrogen-music/hydrogen/tags .*/v?(\d\S+)\.tar\.gz

## hydrogen 1.2.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,8 +18,6 @@
 SET(VERSION_MAJOR "1")
 SET(VERSION_MINOR "2")
 SET(VERSION_PATCH "0")
-SET(VERSION_SUFFIX "beta")
-
 
 SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 
@@ -237,7 +235,13 @@
 	FIND_HELPER(OSS oss sys/soundcard.h OSSlib )
 ENDIF()
 
-FIND_HELPER(JACK jack jack/jack.h jack)
+IF(WIN64)
+  #64bit Windows
+  FIND_HELPER(JACK jack jack/jack.h jack64)
+ELSE()
+  #32bit Windows and all other OS
+  FIND_HELPER(JACK jack jack/jack.h jack)
+ENDIF()
 CHECK_LIBRARY_EXISTS(jack jack_port_rename "" HAVE_JACK_PORT_RENAME)
 IF(APPLE)
     FIND_LIBRARY(AUDIOUNIT_LIBRARY AudioUnit)
@@ -285,11 +289,11 @@
 ENDFOREACH()
 
 # LIBSNDFILE CHECKS
-STRING( COMPARE GREATER "${LIBSNDFILE_VERSION}" "${LIBSNDFILE_VERSION_PREV}" LIBSNDFILE_VERSION_OK)
+STRING( COMPARE GREATER "${PC_LIBSNDFILE_VERSION}" "${LIBSNDFILE_VERSION_PREV}" LIBSNDFILE_VERSION_OK)
 IF(LIBSNDFILE_VERSION_OK)
-    SET(LIBSNDFILE_MSG "libsndfile supports FLAC and OGG sound file formats")
-ELSE()
-	SET(LIBSNDFILE_MSG "libsndfile version must be greater than ${LIBSNDFILE_VERSION_PREV} to support FLAC and OGG sound file formats. Found version: ${LIBSNDFILE_VERSION}")
+    SET(LIBSNDFILE_MSG "${PC_LIBSNDFILE_VERSION}: libsndfile supports FLAC and OGG sound file formats")
+ELSE()
+	SET(LIBSNDFILE_MSG "libsndfile version must be greater than ${LIBSNDFILE_VERSION_PREV} to support FLAC and OGG sound file formats. Found version: ${PC_LIBSNDFILE_VERSION}")
 ENDIF()
 
 # RUBBERBAND information
@@ -344,8 +348,3 @@
 * ${purple}CoreMidi${reset}                     : ${COREMIDI_STATUS}
 * ${purple}PortAudio${reset}                    : ${PORTAUDIO_STATUS}
 * ${purple}PortMidi${reset}                     : ${PORTMIDI_STATUS}
-* ${purple}PulseAudio${reset}                   : ${PULSEAUDIO_STATUS}\n"
-)
-
-COLOR_MESSAGE("${cyan}Useful extensions${reset}
------------------------------------------

=== debian/changelog ===
hydrogen (1.2.0+dfsg-0.1~mx21+1) mx; urgency=medium

  * Import new upstream final 1.2.0 release.
  * Add fix_FTBFS_with_-Werror=format-security.patch, cherry-picked
    from github. 

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 05 Jun 2023 12:24:10 -0700

=== debian/control ===
--- 
+++ 
@@ -1,57 +1,47 @@
 Source: hydrogen
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
 XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
-Uploaders:
- Nicholas D Steeves <sten@debian.org>,
- Dennis Braun <d_braun@kabelmail.de>
-Build-Depends:
- debhelper-compat (= 13),
- cmake,
- qtbase5-dev,
- libqt5xmlpatterns5-dev,
- qttools5-dev,
- libcppunit-dev,
- libz-dev,
- pkg-config,
- libarchive-dev,
- docbook-utils,
- poxml,
- xmlto,
- libxml2-utils,
- libasound2-dev [linux-any],
- libjack-dev,
- liblrdf-dev,
- libsndfile1-dev,
- portaudio19-dev,
- libportmidi-dev [linux-any],
- libpulse-dev,
- liblo-dev,
- libqt5svg5-dev,
- qttools5-dev-tools
+Uploaders: Nicholas D Steeves <sten@debian.org>,
+           Dennis Braun <d_braun@kabelmail.de>
+Build-Depends: cmake,
+               debhelper-compat (= 13),
+               docbook-utils,
+               libarchive-dev,
+               libasound2-dev [linux-any],
+               libcppunit-dev,
+               libjack-dev,
+               liblo-dev,
+               liblrdf-dev,
+               libportmidi-dev [linux-any],
+               libpulse-dev,
+               libqt5svg5-dev,
+               libqt5xmlpatterns5-dev,
+               libsndfile1-dev,
+               libxml2-utils,
+               libz-dev,
+               pkg-config,
+               portaudio19-dev,
+               poxml,
+               qtbase5-dev,
+               qttools5-dev,
+               qttools5-dev-tools,
+               xmlto
 Rules-Requires-Root: no
 Standards-Version: 4.6.1
 Homepage: http://www.hydrogen-music.org/
-# Unfortunately, as of 2020-11-26, https://www.hydrogen-music.org/ has the
-# following SSL cert issue: NET::ERR_CERT_COMMON_NAME_INVALID
-# This is remains unfixed as of 2022-09-28, and was reported here:
-# https://github.com/hydrogen-music/hydrogen/issues/1658
 Vcs-Git: https://salsa.debian.org/multimedia-team/hydrogen.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/hydrogen
 
 Package: hydrogen
 Architecture: any
-Depends:
- ${misc:Depends},
- ${shlibs:Depends},
- hydrogen-data (= ${source:Version})
-Recommends:
- hydrogen-drumkits,
- hydrogen-doc,
- rubberband-cli
-Suggests:
- ladspa-plugin
+Depends: hydrogen-data (= ${source:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends},
+         hydrogen-drumkits
+Recommends: hydrogen-doc, rubberband-cli
+Suggests: ladspa-plugin
 Breaks: hydrogen-data (<< 1.0.1-2)
 Replaces: hydrogen-data (<< 1.0.1-2)
 Description: advanced drum machine/step sequencer

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CMAKE_EXTRA_FLAGS = -DWANT_SHARED=OFF \
 -DWANT_PORTAUDIO=ON \
 -DWANT_PORTMIDI=ON \
 -DWANT_RUBBERBAND=ON

export QTDIR=/usr/lib/qt5

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- $(DEB_CMAKE_EXTRA_FLAGS)

override_dh_auto_build:
	mv ./data/img/h2-icon.bmp ./data/img/h2-icon.png
	dh_auto_build

override_dh_auto_clean:
	mv ./data/img/h2-icon.png ./data/img/h2-icon.bmp || true
	dh_auto_clean

# No dbgsym packages:
override_dh_strip:
	dh_strip --no-automatic-dbgsym

## hydrogen 1.2.2%2Bdfsg

=== Makefile ===
###
### must have the following commandline tools:
###
### itstool  (Debian package: itstool)
### msgfmt   (Debian package: gettext)
### msgmerge (Debian package: gettext)	
### xmlto    (Debian package: xmlto)
### xmllint  (Debian package: libxml2-utils)
###

MANUAL_MASTER = manual.docbook
TUTORIAL_MASTER = tutorial.docbook

XMLTO_OPTS = --stringparam section.autolabel=1 \
	--stringparam use.is.as.filename=1 \
	--stringparam toc.max.depth=3 \
	--stringparam xref.with.number.and.title=0 \
	--stringparam section.label.includes.component.label=1 \
	--stringparam admon.graphics.extension=.svg \
	--stringparam admon.graphics=1 \
	--stringparam admon.style="'margin-left: 5%;'" \
	--stringparam ulink.target="_blank"

ITSTOOL = itstool
MSGMERGE = msgmerge
MSGFMT = msgfmt
XMLTO = xmlto
XMLLINT = xmllint

all: *.html clean

clean:
	-rm -f *.mo *_validated *.dbk *.bak

# Derive language from filename (and extension)
define LANGUAGE =
$$(echo -n $(1) | sed 's/.*_\(..\)\.$(2)/\1/')
endef

%.html: %.dbk %.dbk_validated
	sed -i "s%generated_en/%generated_$(call LANGUAGE,$<,dbk)/%g" $<
	LL=$(call LANGUAGE,$<,dbk) ; \
	$(XMLTO) html-nochunks $(XMLTO_OPTS) \
		--stringparam l10n.gentext.language=$$LL \
		--stringparam html.stylesheet='res/docbook.css' \
		--stringparam html.script='res/docbook.js' \
		--stringparam img.src.path=img/ \
		--stringparam admon.graphics.path=img/admonitions/ \
		-x res/xslt/html/docbook.xsl \
		$<
	LL=$(call LANGUAGE,$<,dbk) ; \
	$(XMLTO) html -o $*_chunked $(XMLTO_OPTS) \
		--stringparam l10n.gentext.language=$$LL \
		--stringparam html.stylesheet='../res/docbook.css' \
		--stringparam html.script='../res/docbook.js' \
		--stringparam img.src.path=../img/ \
		--stringparam admon.graphics.path=../img/admonitions/ \
		-x res/xslt/html/chunk.xsl \
		$<

%.dbk_validated: %.dbk
	$(XMLLINT) --noout --valid $^
	touch $@

## Special rule for master manual and tutorial
%_en.dbk: %.docbook
	cp -f $^ $@

manual_%.dbk: manual_%.mo manual_%.po $(MANUAL_MASTER)
	$(ITSTOOL) -m $< -o $@ --lang $* $(MANUAL_MASTER)

manual_%.po: $(MANUAL_MASTER)
	$(ITSTOOL) -o manual.pot $<
	$(MSGMERGE) -U $@ manual.pot --backup=simple --no-wrap --verbose

manual_%.mo: manual_%.po
	`cat $< | sed 's/, fuzzy//g' > $<.bak`
	$(MSGFMT) --check -o $@ $<.bak

tutorial_%.dbk: tutorial_%.mo tutorial_%.po $(TUTORIAL_MASTER)
	$(ITSTOOL) -m $< -o $@ --lang $* $(TUTORIAL_MASTER)

tutorial_%.po: $(TUTORIAL_MASTER)
	$(ITSTOOL) -o tutorial.pot $<
	$(MSGMERGE) -U $@ tutorial.pot --backup=simple --no-wrap --verbose

tutorial_%.mo: tutorial_%.po
	`cat $< | sed 's/, fuzzy//g' > $<.bak`
	$(MSGFMT) --check -o $@ $<.bak

=== debian/control ===
--- 
+++ 
@@ -1,47 +1,57 @@
 Source: hydrogen
 Section: sound
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
-Uploaders: Nicholas D Steeves <sten@debian.org>,
-           Dennis Braun <d_braun@kabelmail.de>
-Build-Depends: cmake,
-               debhelper-compat (= 13),
-               docbook-utils,
-               libarchive-dev,
-               libasound2-dev [linux-any],
-               libcppunit-dev,
-               libjack-dev,
-               liblo-dev,
-               liblrdf-dev,
-               libportmidi-dev [linux-any],
-               libpulse-dev,
-               libqt5svg5-dev,
-               libqt5xmlpatterns5-dev,
-               libsndfile1-dev,
-               libxml2-utils,
-               libz-dev,
-               pkg-config,
-               portaudio19-dev,
-               poxml,
-               qtbase5-dev,
-               qttools5-dev,
-               qttools5-dev-tools,
-               xmlto
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Uploaders:
+ Nicholas D Steeves <sten@debian.org>,
+ Dennis Braun <d_braun@kabelmail.de>
+Build-Depends:
+ debhelper-compat (= 13),
+ cmake,
+ qtbase5-dev,
+ libqt5xmlpatterns5-dev,
+ qttools5-dev,
+ libcppunit-dev,
+ libz-dev,
+ pkgconf,
+ libarchive-dev,
+ docbook-utils,
+ poxml,
+ xmlto,
+ libxml2-utils,
+ libasound2-dev [linux-any],
+ libjack-dev,
+ liblrdf-dev,
+ libsndfile1-dev,
+ portaudio19-dev,
+ libportmidi-dev [linux-any],
+ libpulse-dev,
+ liblo-dev,
+ libqt5svg5-dev,
+ qttools5-dev-tools,
+ itstool
 Rules-Requires-Root: no
 Standards-Version: 4.6.1
 Homepage: http://www.hydrogen-music.org/
+# Unfortunately, as of 2020-11-26, https://www.hydrogen-music.org/ has the
+# following SSL cert issue: NET::ERR_CERT_COMMON_NAME_INVALID
+# This is remains unfixed as of 2022-09-28, and was reported here:
+# https://github.com/hydrogen-music/hydrogen/issues/1658
 Vcs-Git: https://salsa.debian.org/multimedia-team/hydrogen.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/hydrogen
 
 Package: hydrogen
 Architecture: any
-Depends: hydrogen-data (= ${source:Version}),
-         ${misc:Depends},
-         ${shlibs:Depends},
-         hydrogen-drumkits
-Recommends: hydrogen-doc, rubberband-cli
-Suggests: ladspa-plugin
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+ hydrogen-data (= ${source:Version})
+Recommends:
+ hydrogen-drumkits,
+ hydrogen-doc,
+ rubberband-cli
+Suggests:
+ ladspa-plugin
 Breaks: hydrogen-data (<< 1.0.1-2)
 Replaces: hydrogen-data (<< 1.0.1-2)
 Description: advanced drum machine/step sequencer
@@ -93,6 +103,7 @@
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends}
+Recommends: fonts-noto-core, fonts-b612
 Breaks: hydrogen (<< 0.9.7-1~)
 Replaces: hydrogen (<< 0.9.7-1~)
 Description: advanced drum machine/step sequencer (doc)
